This archive contains a test suite for testing the Operating System loader
library for Windows (`so_loader.dll`). The test suite consists of several
unit tests, each of them testing a different functionality of the loader.

# Archive Files
The checker consists of the following files:
* `README.md` - this file
* `Makefile.checker` - Makefile for automating the build process on Windows
* `GNUmakefile` - Cygwin wrapper over NMakefile.checker
* `run_all.sh` - script to run all tests defined from Cygwin
* `_test` - directory that contains the following:
  * `run_test.sh` - runs only a specific test
  * `test_lib.sh` - a shell library used to run tests
  * `run_test.c` - source file used to run the executable using the
  `so_loader` library and dump the page fault information in a file
  * `loader.h` - SO loader's header
  * `Makefile` - Makefile used for building the testing binary
  * `inputs/` - directory where the testing executables are located
  * `refs/` - directory where tests reference files are stored

# Checker
The checker must be run in Cygwin. The local directory must contain the
so_loader library (`so_loader.dll` and `so_loader.lib`). Use `make`
to properly run the entire test suite:
```
make all
```

# Debug
If you want to keep the reference files after running a test, you have to set
the `DO_CLEANUP` environment variable to `no`:
```
DO_CLEANUP=no make all
```

In order to run a single test, you can manually run the `run_test.sh` script:
```
_test/run_test.sh init
_test/run_test.sh <test>
_test/run_test.sh clean
```

# Cleanup
To clean the files generated by the checker you have to run:
```
make clean
make bclean
```
